package org.wfc.omada.api.sitesetting.model;

import com.fasterxml.jackson.annotation.JsonProperty;
import io.swagger.annotations.ApiModelProperty;

import javax.validation.Valid;
import javax.validation.constraints.NotNull;
import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

/**
 * UpnpSettingOpenApiVo
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.SpringCodegen", date = "2024-12-04T11:32:19.054+08:00[Asia/Shanghai]")

public class UpnpSettingOpenApiVo   {
  @JsonProperty("enable")
  private Boolean enable;

  @JsonProperty("wanPortIds")
  @Valid
  private List<String> wanPortIds = null;

  @JsonProperty("networkIds")
  @Valid
  private List<String> networkIds = null;

  public UpnpSettingOpenApiVo enable(Boolean enable) {
    this.enable = enable;
    return this;
  }

  /**
   * Whether to enable UPnP
   * @return enable
  */
  @ApiModelProperty(required = true, value = "Whether to enable UPnP")
  @NotNull


  public Boolean getEnable() {
    return enable;
  }

  public void setEnable(Boolean enable) {
    this.enable = enable;
  }

  public UpnpSettingOpenApiVo wanPortIds(List<String> wanPortIds) {
    this.wanPortIds = wanPortIds;
    return this;
  }

  public UpnpSettingOpenApiVo addWanPortIdsItem(String wanPortIdsItem) {
    if (this.wanPortIds == null) {
      this.wanPortIds = new ArrayList<>();
    }
    this.wanPortIds.add(wanPortIdsItem);
    return this;
  }

  /**
   * This field represents WAN Port ID, WAN Port ID can be obtained from \"Get internet basic info\" interface.
   * @return wanPortIds
  */
  @ApiModelProperty(value = "This field represents WAN Port ID, WAN Port ID can be obtained from \"Get internet basic info\" interface.")


  public List<String> getWanPortIds() {
    return wanPortIds;
  }

  public void setWanPortIds(List<String> wanPortIds) {
    this.wanPortIds = wanPortIds;
  }

  public UpnpSettingOpenApiVo networkIds(List<String> networkIds) {
    this.networkIds = networkIds;
    return this;
  }

  public UpnpSettingOpenApiVo addNetworkIdsItem(String networkIdsItem) {
    if (this.networkIds == null) {
      this.networkIds = new ArrayList<>();
    }
    this.networkIds.add(networkIdsItem);
    return this;
  }

  /**
   * This field represents LAN Network ID. LAN Network ID can be obtained from \"Get all \"single\"/\"multi\" interface lan network\" interface.
   * @return networkIds
  */
  @ApiModelProperty(value = "This field represents LAN Network ID. LAN Network ID can be obtained from \"Get all \"single\"/\"multi\" interface lan network\" interface.")


  public List<String> getNetworkIds() {
    return networkIds;
  }

  public void setNetworkIds(List<String> networkIds) {
    this.networkIds = networkIds;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    UpnpSettingOpenApiVo upnpSettingOpenApiVo = (UpnpSettingOpenApiVo) o;
    return Objects.equals(this.enable, upnpSettingOpenApiVo.enable) &&
        Objects.equals(this.wanPortIds, upnpSettingOpenApiVo.wanPortIds) &&
        Objects.equals(this.networkIds, upnpSettingOpenApiVo.networkIds);
  }

  @Override
  public int hashCode() {
    return Objects.hash(enable, wanPortIds, networkIds);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class UpnpSettingOpenApiVo {\n");
    
    sb.append("    enable: ").append(toIndentedString(enable)).append("\n");
    sb.append("    wanPortIds: ").append(toIndentedString(wanPortIds)).append("\n");
    sb.append("    networkIds: ").append(toIndentedString(networkIds)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}

